package com.jiuqi.script.rhino;

package .tmp;

import com.jiuqi.script.rhino.LimitedScriptObject;
import java.lang.reflect.Method;
import java.util.HashMap;
import java.util.Map;
import org.mozilla.javascript.JavaAdapter;

public class WrapFactory {
  private Class facade;
  
  private Map mmap;
  
  public static Object wrap(Object obj, Class facade) {
    return (new com.jiuqi.script.rhino.WrapFactory(facade)).wrap(obj);
  }
  
  public static Object wrap(Object obj, Map mmap) {
    return new LimitedScriptObject(obj, mmap);
  }
  
  public static Object unwrap(Object obj) throws NoSuchFieldException, IllegalAccessException {
    return JavaAdapter.getAdapterSelf(LimitedScriptObject.class, obj);
  }
  
  public WrapFactory(Class facade) {
    if (facade == null)
      throw new NullPointerException("facade参数不能为null"); 
    this.facade = facade;
  }
  
  protected Map getMethods() {
    if (this.mmap == null)
      synchronized (this.facade) {
        if (this.mmap != null)
          return this.mmap; 
        Method[] methods = this.facade.getMethods();
        this.mmap = new HashMap<Object, Object>();
        for (int i = 0; i < methods.length; i++)
          this.mmap.put(methods[i].getName(), methods[i]); 
      }  
    return this.mmap;
  }
  
  public Object wrap(Object obj) {
    return wrap(obj, getMethods());
  }
}
